unit uBizRemesasClienteServer;

interface

uses
  schRemesasClienteServer_Intf, uDAInterfaces,
  uDADataTable, uDABusinessProcessor;

const
  BIZ_SERVER_REMESAS_CLIENTE = 'Server.RemesasCliente';
  REF_REMESAS_CLIENTE = 'REF_REMESAS_CLIENTE';

type
  TBizRemesasClienteServer = class(TRemesasClienteBusinessProcessorRules)
  protected
    procedure BeforeProcessChange(Sender: TDABusinessProcessor;
      aChangeType: TDAChangeType; aChange: TDADeltaChange;
      var ProcessChange: Boolean); override;
  end;

implementation

uses
  Dialogs, SysUtils, Variants, uDataModuleServer, uDAClasses, DARemoteService_Impl,
  schRemesasClienteClient_Intf, uBusinessUtils, uReferenciasUtils, uROClasses;

{ TBizRemesasClienteServer }

procedure TBizRemesasClienteServer.BeforeProcessChange(
  Sender: TDABusinessProcessor; aChangeType: TDAChangeType;
  aChange: TDADeltaChange; var ProcessChange: Boolean);
var
  ASchema : TDASchema;
  ACurrentConn : IDAConnection;
  dsData: IDADataset;
  Empresa : Variant;

begin
  inherited;
  case aChangeType of
    ctInsert, ctUpdate: begin
      //Si la referencia no ha sido asignada le asignamos una nosotros
      if (VarIsNull(aChange.NewValueByName[fld_RemesasClienteREFERENCIA]))
      or (VarToStr(aChange.NewValueByName[fld_RemesasClienteREFERENCIA]) = '') then
      begin
        ASchema := BusinessProcessor.Schema;
        ACurrentConn := GetBusinessProcessorConnection(BusinessProcessor);

        try
          //Siempre va a estar rellena
          Empresa := aChange.NewValueByName[fld_RemesasClienteID_EMPRESA];

          dsData := ASchema.NewDataset(ACurrentConn, 'DarReferencia', ['CODIGO', 'EMPRESA'], [REF_REMESAS_CLIENTE, Empresa]);
        except
          RaiseError('No existe la tabla REFERENCIAS');
        end;

        dsData.Active := True;

        if dsData.IsEmpty then
          RaiseError('NO HAY REFERENCIA ' + REF_REMESAS_CLIENTE + ' DECLARADA EN TABLA REFERENCIAS');

        REFERENCIA := dsData.FieldByName('VALOR').AsString;

        try
          ASchema.NewCommand(ACurrentConn, 'ModificarReferencia', ['CODIGO', 'VALOR', 'ID_EMPRESA'], [REF_Remesas_CLIENTE, DarReferenciaSiguiente(REFERENCIA), Empresa]);
        except
          RaiseError('Error al asignar la nueva ' + REFERENCIA + ' referencia en tabla');
        end;

      end;
    end;
  end;
end;

initialization
  RegisterBusinessProcessorRules(BIZ_SERVER_REMESAS_CLIENTE, TBizRemesasClienteServer);

end.
